/*************************************************************
project: <type project name here>
author: <type your name here>
description: <type what this file does>
*************************************************************/

#include "led_Hat_animations.h"
#include "led_hat_functions.h"
#include <SPI.h>

 
#define latchPin 10
#define clockPin 13
#define dataPin  11
#define extraPin 8

//alex
#define button1  A0
#define button2  A1
#define button3  A2
#define button4  A3
/*
//mitchell
#define button1  A3
#define button2  A2
#define button3  A1
#define button4  A0
*/

bool button[4] 			= {0,0,0,0};
int		mode 			= 1;
int		modeFunction 	= 1;

void setup() { 
	//
	pinMode(dataPin,OUTPUT);
	pinMode(clockPin,OUTPUT);
	pinMode(latchPin,OUTPUT);
	pinMode(extraPin,OUTPUT);
	pinMode(button1, INPUT);
	pinMode(button2, INPUT);
	pinMode(button3, INPUT);
	pinMode(button4, INPUT);
	SPI.begin();
	SPI.setBitOrder(LSBFIRST);
	
}

void loop() {
	readButtons();
	controller();
	
	
	//blinkOnOff(1000);
	
	/*
	//all of the animation playlists
	scrolling_fat();
	scrolling_skinny();
	ocean();
	U_Dub();
	texas();
	animation();
	
	//all of the individual effects
	I_Tell_You_What(20);			//Texas
	Swim_Fish(20);					//Ocean
	Hearts_Move(20);				//Animation
	Stay_Classy(20);				
	Zig_Zag_Fat(5);					//Scrolling Fat
	Zig_Zag_Skinny(7);
	Ha_Ha(20);
	animate_Octopus(50);			//Ocean
	animate_PacMan(10);				//Animation
	animate_Space_Invaders(50);		//Animation
	TEHAS(20);						//Texas
	Go_UAF(20);
	//animate_Dancing_Man(100);		//Animation
	Up_Down(5);
	Tan_Curve(8);
	Tan_Curve_Fat(10);
	Bubbles_(25);					//Animation
	//animate_Moving_Eyes(40); 		//needs work
	Go_UW(20);						//U_Dub
	Go_Huskies(20);					//U_Dub
	*/
	
}

void controller() {
	switch(mode) {
		case 1:
			allFunctions(modeFunction);
			break;
			
		case 2:
			playlists(modeFunction);
			break;
			/*
		case 3:
			playlists(modeFunction);
			break;*/
	}
}

void playlists(int whichOne) {
	switch(whichOne) {
		case 1:
			ocean();
			break;
			
		case 2:
			Go_UAF(20);
			break;
			
		case 3:
			scrolling_fat();
			break;
			
		case 4:
			scrolling_skinny();
			break;
			
		case 5:
			texas();
			break;
			
	}
}

void allFunctions(int whichOne) {
	switch(whichOne) {
		case 1:
			TEHAS(20);
			break;
		case 2:
			I_Tell_You_What(20);
			break;
		case 3:
			Stay_Classy(20);
			break;
		case 4:
			Ha_Ha(20);
			break;
		case 5:
			Swim_Fish(20);
			break;
		case 6:
			Hearts_Move(20);
			break;
		case 7:
			Zig_Zag_Fat(5);
			break;
		case 8:
			Zig_Zag_Skinny(7);
			break;
		case 9:
			Tan_Curve(8);
			break;
		case 10:
			Tan_Curve_Fat(10);
			break;
		case 11:
			Up_Down(5);
			break;
		case 12:
			Go_UAF(20);
			break;
			/*
		case 13:
			Go_Huskies(20);
			break;
		case 14:
			Go_UW(20);
			break;
		case 15:
			
			break;
		case 16:
			
			break;*/
	}
	
}


void readButtons() {
	button[0] = digitalRead(button1); //button for individualy switching through functions
	button[1] = digitalRead(button2); //shuffel playlists
	button[2] = digitalRead(button3); //up another playlist or next funtion
	button[3] = digitalRead(button4); //down another playlist or previous funtion
	
	
	//inturtpite the buttons
	if(button[0]) {
		delay(500);
		mode = 1;
		modeFunction = 1;
	}
	
	if(button[1]) {
		delay(500);
		mode = 2;
		modeFunction = 1;
	}
	
	if(button[2]) {
		delay(500);
		if(mode == 1){
			if(modeFunction < 12) {
				modeFunction ++;
			} else {
				modeFunction = 1;
			}
		}
		if(mode == 2){
			if(modeFunction < 5) {
				modeFunction ++;
			} else {
				modeFunction = 1;
			}
		}
		
	}
	
	if(button[3]) {
		delay(500);
		if(mode == 1){
			if(modeFunction > 1) {
				modeFunction --;
			} else {
				modeFunction = 12;
			}
		}
		if(mode == 2){
			if(modeFunction > 1) {
				modeFunction --;
			} else {
				modeFunction =6;
			}
		}
	}
}


int scrolling_skinny() {
//All of the thin scrolling designs
	int abc = 25;
	int modeThink = modeFunction;
	
	do{
		Zig_Zag_Skinny(7);
		abc--;
		if(modeThink != modeFunction){ return 0;}
	}while(abc);
	
	abc = 20;
	do{
		Tan_Curve(8);
		abc--;
		if(modeThink != modeFunction){ return 0;}
	}while(abc);
	
	abc = 36;
	do{
		Up_Down(5);
		abc--;
		if(modeThink != modeFunction){ return 0;}
	}while(abc);
	return 0;
}

int scrolling_fat() {
//All of the thick scrolling designs
	int abc = 30;
	int modeThink = modeFunction;
	
	do{
		Zig_Zag_Fat(5);
		abc--;
		if(modeThink != modeFunction){ return 0;}
	}while(abc);
	
	abc = 20;
	do{
		Tan_Curve_Fat(10);
		abc--;
		if(modeThink != modeFunction){ return 0;}
	}while(abc);
	
	abc = 36;
	do{
		Up_Down(5);
		abc--;
		if(modeThink != modeFunction){ return 0;}
	}while(abc);
	return 0;
}

void animation() {
//Goes through various functions
	int abc = 5;
	do{
		Bubbles_(25);
		abc--;
	}while(abc);
	
	//animate_Dancing_Man(50);
	
	abc = 20;
	do{
		animate_Space_Invaders(50);
		abc--;
	}while(abc);
	
	abc = 25;
	do{
		animate_PacMan(10);
		abc--;
	}while(abc);
	/*
	abc = 8;
	do{
		animate_Moving_Eyes(50);
		abc--;
	}while(abc);*/
	
}

int texas() {
	int modeThink = modeFunction;
	
	TEHAS(20);
	if(modeThink != modeFunction){ return 0;}
	I_Tell_You_What(20);
	return 0;
}

int ocean() {
//Little Fishies and then the Octopus
	int bcd = 5;
	int modeThink = modeFunction;
	
	do{
		int abc = 15;
		do{
			Swim_Fish(20);
			abc--;
			if(modeThink != modeFunction){ return 0;}
		}while(abc);
		
		abc = 4;
		do{
			animate_Octopus(50);
			abc--;
			if(modeThink != modeFunction){ return 0;}
		}while(abc);
		
		bcd--;
		if(modeThink != modeFunction){ return 0;}
	}while(bcd);
	return 0;
}

int U_Dub() {
//University of Washington
	int modeThink = modeFunction;
	
	Go_UW(20);
	if(modeThink != modeFunction){ return 0;}
	Go_Huskies(20);
	return 0;
}

void blinkOnOff(int displaySpeed) {
	latchOff();
	SPI.transfer(0xff);
	SPI.transfer(0xff);
	SPI.transfer(0xff);
	SPI.transfer(0xff);
	extraOn();
	latchOn();
	delay(displaySpeed);

	latchOff();
	SPI.transfer(0x00);
	SPI.transfer(0x00);
	SPI.transfer(0x00);
	SPI.transfer(0x00);
	extraOff();
	latchOn();
	delay(displaySpeed);
}

void shiftClockwise() {
//Moves all of the data in clockwise 1 step
	int tempDataStore[8][2];
	for(int rows = 0; rows <= 7; rows++) {
	
		displayDataExtra[rows] = 0; 
		tempDataStore[rows][1] = 0;
		tempDataStore[rows][0] = 0;
		
		int temptemp = (0x80&displayData[rows][2]);
		displayDataExtra[rows] |= (temptemp>>7);
		
		temptemp = (0x80&displayData[rows][1]);
		tempDataStore[rows][1] |= (temptemp>>7);
		
		temptemp = (0x80&displayData[rows][0]);
		tempDataStore[rows][0] |= (temptemp>>7);
	}
	
	for(int rows = 0; rows <= 7; rows++) { 
		displayData[rows][2] <<= 1;
		displayData[rows][1] <<= 1;
		displayData[rows][0] <<= 1;
		
		displayData[rows][2] |= 0x01&tempDataStore[rows][1];
		displayData[rows][1] |= 0x01&tempDataStore[rows][0];
	}
}

void dataToDisplay(int holdTime) {
	
	do{
		for(int rows = 0; rows <= 7; rows++) {
			dataTransfer(displayData[rows][0], displayData[rows][1], 
						 displayData[rows][2], displayDataExtra[rows], rows);
			delay(1);
			//dataTransfer(0,0,0,0,0); //It doesn't appear to need this function...
		}
		holdTime--;
	}while(holdTime);
}


void dataTransfer(int oneData, int twoData, int threeData, bool extraData, int rowNumber){
	readButtons();
	latchOff();
	SPI.transfer(rowCounter[rowNumber]);
	SPI.transfer(oneData);
	SPI.transfer(twoData);
	SPI.transfer(threeData);
	latchOn();
	if(extraData) {
		extraOn();
	} else {
		extraOff();
	}
 
}

void clearDisplayData() {
	for(int www = 0; www < 7; www++) {
		for(int lll = 0; lll < 2; lll++) {
			displayData[www][lll] = 0x00;
		}
		displayDataExtra[www] = false;
	}
}

void clearDisplayBuffer() {
	for(int www = 0; www < 7; www++) {
		for(int lll = 0; lll < 2; lll++) {
			displayBuffer[www][lll] = 0x00;
		}
		displayBufferExtra[www] = 0;
	}
}


void extraOn() {
	PORTB |= (1<<PORTB0);
	//digitalWrite(extraPin, HIGH);
}

void extraOff() {
	PORTB &= ~(1<<PORTB0);
	//digitalWrite(extraPin, LOW);
}

void latchOn() {
	PORTB |= (1<<PORTB2);
}

void latchOff() {
	PORTB &= ~(1<<PORTB2);
}